'*******************************************************************************
'                             Pad with vibration
'                               - Rumblepad 2 -
'*******************************************************************************
'                             BASCOM-AVR v.2.0.7.6
'                                MrShilov 2013
$hwstack = 40
$swstack = 40
$framesize = 50
$regfile = "m8def.dat"
$crystal = 12000000
Config Error = Ignore , 380 = Ignore                        '  BASCOM-AVR .2.0.7.6  
$include "Usb_config.inc"
'*******************************************************************************
Row0 Alias Portc.5
Row1 Alias Portd.0
Row2 Alias Portd.1
Row3 Alias Portd.4
Col0 Alias Pind.5
Col1 Alias Pind.6
Col2 Alias Pind.7
Col3 Alias Pinb.0

Dim Resetcounter As Word
Dim Idlemode As Byte
Dim Temp_word As Word
Dim Dpad_x As Word
Dim Dpad_y As Word
Dim Rjoy_x As Word
Dim Rjoy_y As Word
Dim Buttons As Word
Dim Hat As Byte
Dim I As Byte

Config Timer2 = Pwm , Prescale = 8 , Compare Pwm = Clear Up
Pwm2 = 0

Config Timer1 = Pwm , Pwm = 8 , Compare_a_pwm = Clear_up , Compare_b_pwm = Clear_up , Prescale = 8
Compare1a = 0
Compare1b = 0
Config Portb.1 = Output
Config Portb.2 = Output

Config Adc = Single , Prescaler = Auto , Reference = Avcc
Start Adc

'*********************************  ***********************************
Enable Interrupts
Gosub Clear_ports

Do

Resetcounter = 0
   While _usb_pin._usb_dminus = 0                           ' 
      Incr Resetcounter
      If Resetcounter = 1000 Then
         Call Usb_reset()
      End If
   Wend

   If _usb_status._usb_rxc = 1 Then                         '   
      If _usb_status._usb_setup = 1 Then
         Call Usb_processsetup(_usb_tx_status)

      Elseif _usb_status._usb_endp1 = 1 Then
         Select Case _usb_rx_buffer(2)
            Case 81
               Compare1a = _usb_rx_buffer(4)                ' 
               Compare1b = _usb_rx_buffer(6)                ' 
               Pwm2 = _usb_rx_buffer(4)                     ' 
               If _usb_rx_buffer(6) > _usb_rx_buffer(4) Then Pwm2 = _usb_rx_buffer(6)
            Case 243                                        ' 
               Pwm2 = 0
               Compare1a = 0
               Compare1b = 0
         End Select

      End If

      _usb_status._usb_rtr = 1                              ' RTR-  (   )
      _usb_status._usb_rxc = 0                              ' RXC-

   End If

   If _usb_tx_status2._usb_txc = 1 Then

      '-------------------------   --------------------------
      Dpad_x = 0
      Dpad_y = 0
      For I = 1 To 4                                        '4    ""
         Temp_word = Getadc(0)
         Dpad_x = Dpad_x + Temp_word
         Temp_word = Getadc(2)
         Dpad_y = Dpad_y + Temp_word
         Temp_word = Getadc(1)
         Rjoy_x = Rjoy_x + Temp_word
         Temp_word = Getadc(3)
         Rjoy_y = Rjoy_y + Temp_word
      Next I
      Shift Dpad_x , Right , 4                              '  255
      Shift Dpad_y , Right , 4
      Shift Rjoy_x , Right , 4
      Shift Rjoy_y , Right , 4
      If Rjoy_x > 254 Then Rjoy_x = 254
      If Rjoy_y > 254 Then Rjoy_y = 254

      '------------------------   -------------------------------
      Buttons = 0
      Gosub Clear_ports : Config Row0 = Output : Row0 = 0 : Waitus 50
         Buttons.4 = Not Col0                               '1
         Buttons.8 = Not Col1                               '5
         Buttons.12 = Not Col2                              '9
         Hat.0 = Not Col3                                   ' - Hat "/\"

      Gosub Clear_ports : Config Row1 = Output : Row1 = 0 : Waitus 50
         Buttons.5 = Not Col0                               '2
         Buttons.9 = Not Col1                               '6
         Buttons.13 = Not Col2                              '10
         Hat.1 = Not Col3                                   ' - Hat ">"

      Gosub Clear_ports : Config Row2 = Output : Row2 = 0 : Waitus 50
         Buttons.6 = Not Col0                               '3
         Buttons.10 = Not Col1                              '7
         Buttons.14 = Not Col2                              '11
         Hat.2 = Not Col3                                   ' - Hat "\/"

      Gosub Clear_ports : Config Row3 = Output : Row3 = 0 : Waitus 50
         Buttons.7 = Not Col0                               '4
         Buttons.11 = Not Col1                              '8
         Buttons.15 = Not Col2                              '12
         Hat.3 = Not Col3                                   ' - Hat "<"

      Select Case Hat
         Case 0 : I = 15                                    'Hat  
         Case 1 : I = 0                                     ' /\ ,   = 0
         Case 2 : I = 2                                     '> 
         Case 3 : I = 1                                     '/\  > 
         Case 4 : I = 4                                     '\/ 
         Case 6 : I = 3                                     '>  \/ 
         Case 8 : I = 6                                     '< 
         Case 9 : I = 7                                     ' <  /\ 
         Case 12 : I = 5                                    ' <  \/ 
      End Select
      Buttons = Buttons + I                                 '   Hat

      '-------------------------     --------------------------
      _usb_tx_buffer2(2) = Low(dpad_x)
      _usb_tx_buffer2(3) = Low(dpad_y)
      _usb_tx_buffer2(4) = Low(rjoy_x)
      _usb_tx_buffer2(5) = Low(rjoy_x)
      _usb_tx_buffer2(6) = Low(rjoy_y)
      _usb_tx_buffer2(7) = Low(buttons)
      _usb_tx_buffer2(8) = High(buttons)
      _usb_tx_buffer2(9) = 64
      Call Usb_send(_usb_tx_status2 , 8)
   End If

Loop

End
'===============================================================================
Clear_ports:
Config Row0 = Input : Row0 = 1
Config Row1 = Input : Row1 = 1
Config Row2 = Input : Row2 = 1
Config Row3 = Input : Row3 = 1
Return

$include "Descriptors.inc"