$nocompile
'*******************************************************************************
'**************** ,   EEPROM  FLASH ******************
#if _usb_use_eeprom = 1
   $eeprom
#else
   $data
#endif

' 
_usb_devicedescriptor:
Data 18 , 18 , _usb_desc_device , _usb_specl , _usb_spech , _usb_devclass
Data _usb_devsubclass , _usb_devprot , 8 , _usb_vidl , _usb_vidh , _usb_pidl
Data _usb_pidh , _usb_devrell , _usb_devrelh , _usb_imanufacturer
Data _usb_iproduct , _usb_iserial , _usb_numconfigs

_usb_configdescriptor:
Data _usb_descr_total , 9 , _usb_desc_config , _usb_descr_totall
Data _usb_descr_totalh , _usb_numifaces , _usb_confignum , _usb_iconfig
Data _usb_powered , _usb_maxpower

Data 9 , _usb_desc_iface , _usb_ifaceaddr , _usb_alternate
Data _usb_ifaceendpoints , _usb_ifclass , _usb_ifsubclass , _usb_ifprotocol
Data _usb_iiface

#if _usb_hids > 0
   Data _usb_hid_descr_len , _usb_desc_hid , _usb_hid_releasel , _usb_hid_releaseh
   Data _usb_hid_country , _usb_hid_numdescriptors
   Data _usb_desc_report
   Data 134 , 0
#endif

#if _usb_endpoints > 1
   Data 7 , _usb_desc_endpoint , _usb_endp2attr , _usb_endp2type , 8 , 0
   Data _usb_endp2interval
#endif

#if _usb_endpoints > 2
   Data 7 , _usb_desc_endpoint , _usb_endp3attr , _usb_endp3type , 8 , 0
   Data _usb_endp3interval
#endif

#if _usb_hids > 0
   _usb_hid_reportdescriptor:

   Data 134
   Data &H05 , &H01                                         '  Usage Page (Desktop),
   Data &H09 , &H04                                         '  Usage (Joystik),
   Data &HA1 , &H01                                         '  Collection (Application),
   Data &HA1 , &H02                                         '      Collection (Logical),
   Data &H95 , &H01                                         '          Report Count (1 field),
   Data &H75 , &H0C                                         '          Report Size (12 bit),
   Data &H14                                                '          Logical Minimum (0),
   Data &H26 , &HFF , &H0F                                  '          Logical Maximum (4095),
   Data &H34                                                '          Physical Minimum (0),
   Data &H46 , &HFF , &H0F                                  '          Physical Maximum (4095),
   Data &H09 , &H30                                         '          Usage (X),
   Data &H81 , &H02                                         '              >>>> Input (Variable), *** Wheel ***
   Data &H05 , &H01                                         '          Usage Page (Desktop),
   Data &H95 , &H01                                         '          Report Count (1 field),
   Data &H75 , &H04                                         '          Report Size (4 bit),
   Data &H25 , &H07                                         '          Logical Maximum (7),
   Data &H46 , &H3B , &H01                                  '          Physical Maximum (315),
   Data &H65 , &H14                                         '          Unit (Degrees),
   Data &H09 , &H39                                         '          Usage (Hat Switch),
   Data &H81 , &H42                                         '              >>>> Input (Variable), *** Hat ***
   Data &H95 , &H13                                         '          Report Count (19 fields),
   Data &H75 , &H01                                         '          Report Size (1 bit),
   Data &H25 , &H01                                         '          Logical Maximum (1),
   Data &H45 , &H01                                         '          Physical Maximum (1),
   Data &H05 , &H09                                         '          Usage Page (Button),
   Data &H19 , &H01                                         '          Usage Minimum (01h),
   Data &H29 , &H13                                         '          Usage Maximum (13h),
   Data &H81 , &H02                                         '              >>>> Input (Variable), *** Buttons ***
   Data &H05 , &H01                                         '          Usage Page (Desktop),
   Data &H95 , &H01                                         '          Report Count (1 field),
   Data &H75 , &H07                                         '          Report Size (7 bit),
   Data &H14                                                '          Logical Minimum (0),
   Data &H26 , &H7F , &H00                                  '          Logical Maximum (127),
   Data &H34                                                '          Physical Minimum (0),
   Data &H46 , &H7F , &H00                                  '          Physical Maximum (127),
   Data &H09 , &H32                                         '          Usage (Z),
   Data &H81 , &H02                                         '              >>>> Input (Variable), *** Accelerator ***
   Data &H95 , &H01                                         '          Report Count (1 field),
   Data &H75 , &H07                                         '          Report Size (7 bit),
   Data &H14                                                '          Logical Minimum (0),
   Data &H26 , &H7F , &H00                                  '          Logical Maximum (127),
   Data &H34                                                '          Physical Minimum (0),
   Data &H46 , &H7F , &H00                                  '          Physical Maximum (127),
   Data &H09 , &H35                                         '          Usage (Rz),
   Data &H81 , &H02                                         '              >>>> Input (Variable), *** Brake ***
   Data &H95 , &H01                                         '          Report Count (1 field),
   Data &H75 , &H07                                         '          Report Size (7 bit),
   Data &H14                                                '          Logical Minimum (0),
   Data &H26 , &H7F , &H00                                  '          Logical Maximum (127),
   Data &H34                                                '          Physical Minimum (0),
   Data &H46 , &H7F , &H00                                  '          Physical Maximum (127),
   Data &H09 , &H36                                         '          Usage (Slider),
   Data &H81 , &H02                                         '              >>>> Input (Variable), *** Clutch ***
   Data &H95 , &H01                                         '          Report Count (1 field),
   Data &H75 , &H08                                         '          Report Size (8 bit),
   Data &H14                                                '          Logical Minimum (0),
   Data &H26 , &HFF , &H00                                  '          Logical Maximum (255),
   Data &H34                                                '          Physical Minimum (0),
   Data &H46 , &HFF , &H00                                  '          Physical Maximum (255),
   Data &H09 , &H31                                         '          Usage (Y),
   Data &H81 , &H02                                         '              >>>> Input (Variable), *** Combined pedals ***
   Data &HC0                                                '      End Collection,
   Data &HA1 , &H02                                         '      Collection (Logical),
   Data &H09 , &H02                                         '          Usage (02h),
   Data &H95 , &H07                                         '          Report Count (7 fields),
   Data &H91 , &H02                                         '              <<<< Output (Variable), *** FFB & Control ***
   Data &HC0                                                '      End Collection,
   Data &HC0                                                '  End Collection

#endif

'***************************   *****************************
_usb_langdescriptor:
Data 4 , 4 , _usb_desc_string , 09 , 04

_usb_mandescriptor:
Data 22 , 22 , _usb_desc_string
Data "M" , "C" , "S" , "-" , "B" , "a" , "s" , "c" , "o" , "m"

_usb_proddescriptor:
Data 38 , 38 , _usb_desc_string
Data "G" , "2" , "5" , " " , "F" , "e" , "e" , "d" , "b" , "a" , "c" , "k" , " " , "W" , "h" , "e" , "e" , "l"

'*******************************************************************************
'*******************************  **********************************
Sub Usb_processsetup(txstate As Byte)

Senddescriptor = 0
   Txstate = _usb_setup_sync
   Select Case _usb_rx_buffer(2)
      Case &B10000000:
         Select Case _usb_rx_buffer(3)
            Case _usb_req_get_descriptor:
               Select Case _usb_rx_buffer(5)
                  Case _usb_desc_device:
                     #if _usb_use_eeprom = 1
                        Readeeprom _usb_eepromaddrl , _usb_devicedescriptor
                     #else
                        Restore _usb_devicedescriptor
                     #endif
                     Senddescriptor = 1
                  Case _usb_desc_config:
                     #if _usb_use_eeprom = 1
                        Readeeprom _usb_eepromaddrl , _usb_configdescriptor
                     #else
                        Restore _usb_configdescriptor
                     #endif
                     Senddescriptor = 1
                  Case _usb_desc_string:
                     Select Case _usb_rx_buffer(4)
                        Case 0:
                           #if _usb_use_eeprom = 1
                              Readeeprom _usb_eepromaddrl , _usb_langdescriptor
                           #else
                              Restore _usb_langdescriptor
                           #endif
                           Senddescriptor = 1
                        Case 1:
                           #if _usb_use_eeprom = 1
                              Readeeprom _usb_eepromaddrl , _usb_mandescriptor
                           #else
                              Restore _usb_mandescriptor
                           #endif
                           Senddescriptor = 1
                        Case 2:
                           #if _usb_use_eeprom = 1
                              Readeeprom _usb_eepromaddrl , _usb_proddescriptor
                           #else
                              Restore _usb_proddescriptor
                           #endif
                           Senddescriptor = 1
                     End Select
               End Select
         End Select
      Case &B00000000:
         Select Case _usb_rx_buffer(3)
            Case _usb_req_set_address:
               Call Usb_send(txstate , 0)
               While Txstate._usb_txc = 0 : Wend
               _usb_deviceid = _usb_rx_buffer(4)
            Case _usb_req_set_config:
               Call Usb_send(txstate , 0)
         End Select
      Case &B10000001:
         Select Case _usb_rx_buffer(3)
            Case _usb_req_get_descriptor
               Select Case _usb_rx_buffer(5)
                  Case _usb_desc_report:
                     #if _usb_use_eeprom = 1
                        Readeeprom _usb_eepromaddrl , _usb_hid_reportdescriptor
                     #else
                        Restore _usb_hid_reportdescriptor
                     #endif
                     Senddescriptor = 1
               End Select
         End Select
      Case &B00100001:
         Select Case _usb_rx_buffer(3)
            Case _usb_req_set_idle:
               Idlemode = 1
               Call Usb_send(txstate , 0)
         End Select
   End Select

   If Senddescriptor = 1 Then
      Call Usb_senddescriptor(txstate , _usb_rx_buffer(8))
   End If

End Sub

Sub Usb_senddescriptor(txstate As Byte , Maxlen As Byte)
   Local Size As Byte
   Local I As Byte
   Local J As Byte
   Local Timeout As Word

   #if _usb_use_eeprom = 1
      Size = _usb_eepromaddrl
      push R24
      in R24, EEARL
      sts {_USB_EEPROMADDRL}, R24
      in R24, eearH
      sts {_USB_EEPROMADDRH}, R24
      pop R24
   #else
      Read Size
   #endif


   If Maxlen < Size Then Size = Maxlen
   I = 2
   For J = 1 To Size
      Incr I
      #if _usb_use_eeprom = 1
         Incr _usb_eepromaddr
         Readeeprom Txstate(i) , _usb_eepromaddr
      #else
         Read Txstate(i)
      #endif

      If I = 10 Or J = Size Then
         I = I - 2
         Call Usb_send(txstate , I)
         While Txstate._usb_txc = 0
            Timeout = 0
            'To prevent an infinite loop, check for reset here
            While _usb_pin._usb_dminus = 0
               Incr Timeout
               If Timeout = 1000 Then                       '
                  Call Usb_reset()
                  Exit Sub
               End If
            Wend
         Wend
         I = 2
      End If
   Next
End Sub

Sub Usb_send(txstate As Byte , Byval Count As Byte)
   Txstate = Txstate And _usb_syncmask
   _usb_crc = 0
   If Count <> 0 Then
      _usb_crc = Crc16uni(txstate(3) , Count , &HFFFF , &H8005 , 1 , 1)
      Toggle _usb_crc
   End If
   Count = Count + 3
   Txstate = Txstate + Count
   Txstate(count) = Low(_usb_crc)
   Incr Count
   Txstate(count) = High(_usb_crc)
   Txstate(2) = _usb_pid_data1
   If Txstate._usb_txsync = 0 Then
      Txstate(2) = _usb_pid_data0
   End If
   Txstate._usb_rtt = 1
   Txstate._usb_txc = 0
End Sub

Sub Usb_reset()
   _usb_status._usb_rtr = 1
   _usb_status._usb_rxc = 0
   _usb_tx_status = _usb_endp_init
   #if Varexist( "_usb_Endp2Addr")
   _usb_tx_status2 = _usb_endp_init
   #endif
   #if Varexist( "_usb_Endp3Addr")
   _usb_tx_status3 = _usb_endp_init
   #endif
   _usb_deviceid = 0
   Idlemode = 0
End Sub